/*-
 * Copyright (C)2000, 2001, 2002 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Portions Copyright (c) 1996-2003, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 * $Id: compat.h,v 1.1 2007/03/10 04:12:27 babolo Exp $
 */

typedef struct CompatPageHeader {
    size_t        pd_size;
    size_t        maxoff;
    ItemIdData   *pd_linp;      /* line pointer array                     */
    XLogRecPtr    pd_lsn;       /* LSN: next byte after last byte of xlog */
    StartUpID     pd_sui;       /* SUI of last changes (currently it's    */
    LocationIndex pd_lower;     /* offset to start of free space          */
    LocationIndex pd_upper;     /* offset to end of free space            */
    LocationIndex pd_special;   /* offset to start of special space       */
    u_int16_t     pd_pagesize;
    u_int16_t     pd_version;
} CompatPageHeader;

#define PageIsEmpty(page)              ((page)->pd_lower <= (page)->pd_size)
#define PageIsNew(page)                ((page)->pd_upper == 0)

typedef struct CompatTupleHeader {
    size_t          t_size;
    u_int8_t       *t_bits;
    Oid             t_oid;      /* OID of this tuple -- 4 bytes           */
    CommandId       t_cmin;     /* insert CID stamp -- 4 bytes each       */
    CommandId       t_cmax;     /* delete CommandId stamp                 */
    TransactionId   t_xmin;     /* insert XID stamp -- 4 bytes each       */
    TransactionId   t_xmax;     /* delete XID stamp                       */
    ItemPointerData t_ctid;     /* current TID of this or newer tuple     */
    int16_t         t_natts;    /* number of attributes                   */
    u_int16_t       t_infomask; /* various infos                          */
    u_int8_t        t_hoff;     /* sizeof() tuple header                  */
} CompatTupleHeader;
