/*-
 * Copyright (C)2000, 2001, 2002 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Portions Copyright (c) 1996-2003, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 * $Id: pgsadump.h,v 1.7 2007/03/10 04:12:27 babolo Exp $
 */

typedef struct PGsaDumpCtl {
    BLIN_flag flags;
    size_t    blksz;
    int       ind_maxk;
    u_int16_t nbase;
    u_int16_t alignmax;
    u_int16_t atrmax;
    u_int16_t atrmin;
    u_int16_t atrterm;
    u_int16_t atrmask;
    u_int16_t pd_ver;
    u_int16_t atrs[300];
} PGsaDumpCtl;

#define PGsaDumpNULS 0x000001 /*   t_bits                            */
#define PGsaDumpCTID 0x000002 /*  ctid                                     */
#define PGsaDumpOID  0x000004 /*  oid                                      */
#define PGsaDumpXMIN 0x000008 /*  xmin                                     */
#define PGsaDumpCMIN 0x000010 /*  cmin                                     */
#define PGsaDumpXMAX 0x000020 /*  xmax                                     */
#define PGsaDumpCMAX 0x000040 /*  cmax                                     */
#define PGsaDumpINFO 0x000080 /*   t_infomask                        */
#define PGsaDumpNATR 0x000100 /*                        */
#define PGsaDumpRTID 0x000200 /*                               */
#define PGsaDumpXATR 0x000800 /*   atrmax                   */
#define PGsaDumpXVER 0x001000 /*     LayoutVersion */
#define PGsaDumpXBSZ 0x002000 /*     PageSize      */
#define PGsaDumpXCOL 0x004000 /*               */
#define PGsaDumpXTUP 0x008000 /*            */
#define PGsaDumpLNUS 0x010000 /*     LP_USED                   */
#define PGsaDumpLDEL 0x020000 /*     LP_DELETE                 */
#define PGsaDumpETID 0x040000 /*      ctid         */
#define PGsaDumpTINT 0x100000 /* HAVE_INT64_TIMESTAMP                              */

typedef struct PGsaDumpCollection_t {
    int   (*conv)(PGsaDumpCtl *ctl, void *inbuf, int context);
    int16_t len;
    int16_t align;
    char   *delim;
    char   *descr;
} PGsaDumpCollection_t;

/*  */
#define PGsaDumpAQ  0x01 /* in array                */
#define PGsaDumpBA  0x02 /* bytea                   */
#define PGsaDumpAL  0x04 /*                 */
#define PGsaDumpUP(z,p)                                              \
    ( ((((z & PGsaDumpEL) ? (z & PGsaDumpEL) + 1 : p)) & PGsaDumpEL) \
    | (z & ~(PGsaDumpEL | PGsaDumpAL))                               \
    )

extern PGsaDumpCollection_t PGsaDumpCollection[][23];
int PGsaDumpBlock  __P((PGsaDumpCtl *ctl, u_int32_t pageN, void *PGfilepage));
